/* callbacks for cap_window
 * 2003.05.17 -
 * Time-stamp: <2005-01-10 18:19:01 dimm>
 */

#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#include "seemon2.h"

GtkWidget *dialog, *rb[3];

/* expose-event */
gboolean on_darea_expose (GtkWidget *widget, 
			 GdkEventExpose *event, 
			 gpointer user_data) {
  int i;

  #ifdef DEBUG
  printf("expose-event occured.\n");
  #endif

  if ((copy_to_gray_buffer())) {
    gdk_draw_gray_image (GDK_DRAWABLE(widget->window), widget->style->fg_gc[GTK_STATE_NORMAL],
			 0, 0, wid, hgt,
			 GDK_RGB_DITHER_MAX, graybuf, wid);
  } 

  for (i=0; i<2; i++) {
    #ifdef DEBUG
    printf("flg_set_rect %d : %d\n", i, flg_set_rect[i]);
    #endif
    if (flg_set_rect[i]) {
      draw_rect(widget, i);
    }
  }
}

/* callback for a mouse click */
int on_click_darea (GtkWidget *widget, 
		    GdkEventButton *event) {
  if (event->button == 1) {
    /* left button is clicked */
    mseemon.star_center[0].cx = (int)(event->x + 0.5);
    mseemon.star_center[0].cy = (int)(event->y + 0.5);
    flg_set_rect[0] = 1;
  } else if (event->button == 3) {
    /* right button is clicked */
    mseemon.star_center[1].cx = (int)(event->x + 0.5);
    mseemon.star_center[1].cy = (int)(event->y + 0.5);
    flg_set_rect[1] = 1;
  }
  return(EXIT_SUCCESS);
}

/* set lamps
 * 2003.05.17
 * not completed
 */
void set_lamp(GtkWidget *widget, int color) {
  GdkGC *gc;

  //  gc = gdk_gc_new(GDK_DRAWABLE(widget->window));
  //  gdk_gc_set_foreground(gc, &mcolor[color]);
  //  gdk_gc_set_background(gc, &mcolor[color]);
  //  #ifdef DEBUG
  //  printf("set_lamp called: ");
  //  #endif
  //  gdk_draw_rectangle(GDK_DRAWABLE(widget->window), gc, TRUE, 0, 0, (wid/3), 20);
  if (color == 0) {
    gdk_draw_rectangle(GDK_DRAWABLE(widget->window), widget->style->black_gc, TRUE, 0, 0, (wid/3), 20);
  } else {
    gdk_draw_rectangle(GDK_DRAWABLE(widget->window), widget->style->white_gc, TRUE, 0, 0, (wid/3), 20);
  }
  //  gdk_gc_destroy(gc);
  //  #ifdef DEBUG
  //  printf("set_lamp finished.\n");
  //  #endif
}

/* callback for lamps */
gboolean on_lamp_expose (GtkWidget *widget, 
			 GdkEventExpose *event) {
  int i;
  GdkGC *gc;

  //  #ifdef DEBUG
  //  printf("on_lamp_expose called: ");
  //  printf("widget:%p \n", widget);
  //  #endif
  gc = gdk_gc_new(GDK_DRAWABLE(widget->window));
  gdk_draw_rectangle (GDK_DRAWABLE(widget->window), 
		      gc, TRUE, 0, 0, (wid/3), 20);

  if (widget == g_lamp_area1) {
    if (mseemon.is_tracking) {
      set_lamp(widget, 1);
    } else {
      set_lamp(widget, 0);
    }
  } else if (widget == g_lamp_area2) {
    if (mseemon.is_capturing >= 2) {
      set_lamp(widget, 1);
    } else {
      set_lamp(widget, 0);
    }
  } else if (widget == g_lamp_area3) {
    if (mseemon.is_recording) {
      set_lamp(widget, 1);
    } else {
      set_lamp(widget, 0);
    }
  }
  gdk_gc_destroy(gc);
} 


/* callback for track star button */
void callback_track_button(GtkWidget *widget, gpointer pointer)
{
  if (mseemon.is_tracking) {
    /* stop tracking */
    mseemon.is_tracking = 0;
    /* stop guiding added v0.4.3 2003.05.29 */
    mseemon.is_guiding = 0;
    gtk_button_set_label(GTK_BUTTON(widget), "Start Tracking");
    set_lamp(g_lamp_area1, 0);
  } else {
    /* start tracking */
    mseemon.is_tracking = 1;
    gtk_button_set_label(GTK_BUTTON(widget), " Stop Tracking");
    set_lamp(g_lamp_area1, 1);
  }
}

/* callback for analysis button */
void callback_ana_button(GtkWidget *widget, gpointer pointer)
{

  if (mseemon.is_capturing == 2) {
    /* stop analysis mode */
    mseemon.is_capturing = 1;
    gtk_button_set_label(GTK_BUTTON(widget), "Start Analysis");
    set_lamp(g_lamp_area2, 0);
    /* set timer time */
    mseemon.time_reload = mseemon.time_reload1;
    /* reset counts */
    n_calc_r0 = 0;
    /* restart timer */
    if (timertag != -1) {
      /* stop current working timer */
      stoptimer();
    }
    starttimer();
  } else {
    mseemon.is_capturing = 2;
    gtk_button_set_label(GTK_BUTTON(widget), " Stop Analysis");
    set_lamp(g_lamp_area2, 1);
    /* set timer time */
    mseemon.time_reload = mseemon.time_reload2;
    /* restart timer */
    if (timertag != -1) {
      /* stop current working timer */
      stoptimer();
    }
    starttimer();
  }
}

/* callback for record button */
void callback_record_button(GtkWidget *widget, gpointer pointer)
{

  if (mseemon.is_recording) {
    /* stop recording */
    mseemon.is_recording = 0;
    gtk_button_set_label(GTK_BUTTON(widget), "Start Recording");
    set_lamp(g_lamp_area3, 0);
  } else {
    mseemon.is_recording = 1;
    gtk_button_set_label(GTK_BUTTON(widget), " Stop Recording");
    set_lamp(g_lamp_area3, 1);
  }
}

/* callback for reset star pos. button */
void callback_reset_starpos(GtkWidget *widget, gpointer pointer)
{
  int ret;
  ret = get_stars(); /* in find_star.c */
  if (!ret) {
    /* succeeded */
    flg_set_rect[0] = 1;
    flg_set_rect[1] = 1;
  } else {
    /* failed */
    flg_set_rect[0] = 0;
    flg_set_rect[1] = 0;
  }

  #ifdef DEBUG
  ret = get_finder_starpos();
  #endif
}

/* exec reset 
 * modified from callback_reset
 * v.0.4.8 2003.08.16
 */
void reset_starfinding(void) {
  int i;

  for (i=0; i<2; i++) {
    mseemon.cg[i].x = 0.;
    mseemon.cg[i].y = 0.;
    mseemon.oldcg[i].x = 0.;
    mseemon.oldcg[i].y = 0;
    flg_set_rect[i] = 0;
    mseemon.prevgdiff[i].cx = -999;
    mseemon.prevgdiff[i].cy = -999;
  }
  n_calc_r0 = 1;
  /*  n_totalsample = 0; /* commented out v0.5.10 2004.10.19 iwata */
  mseemon.is_tracking = 0;
  mseemon.is_recording = 0;
  mseemon.is_capturing = 1;
  mseemon.is_guiding = 0; /* added v0.5.3 2003.10.03 */
  mseemon.ntry2 = 0;      /* added v0.6.6 2004.12.10 */
  gtk_button_set_label(GTK_BUTTON(btn1), "Start Tracking");
  gtk_button_set_label(GTK_BUTTON(btn2), "Start Analysis");
  gtk_button_set_label(GTK_BUTTON(btn3), "Start Recording");
  set_lamp(g_lamp_area1, 0);
  set_lamp(g_lamp_area2, 0);
  set_lamp(g_lamp_area3, 0);

}

/* callback for reset button */
/*
 * this function is implemented in ver.0.2.5
 */
void callback_reset(GtkWidget *widget, gpointer pointer)
{
  //  GtkWidget* w;

  /* to-do: confirmation dialog */

  reset_starfinding();
}

/* Set Currnet Finder Pos. as Target */
void callback_set_targetpos(GtkWidget *widget, gpointer pointer)
{
  int ret;

  ret = get_finder_starpos(); /* in find_star.c */

  if (ret == EXIT_SUCCESS) {
    mseemon.finder_targetpos.cx = mseemon.finder_star_center.cx;
    mseemon.finder_targetpos.cy = mseemon.finder_star_center.cy;
    if (fout != NULL) {
      fprintf(fout, "# set finder %d,%d as target position.\n",
	      mseemon.finder_targetpos.cx,
	      mseemon.finder_targetpos.cy);
    }
  }
}

/* point and center */
void callback_point_and_center(GtkWidget *widget, gpointer data)
{
  int ret, flg, cnt;

  /* to-do: check star is selected */
  if ((ret = point_meade())!= EXIT_SUCCESS) {
    printf("# pointing failed.\n");
    return;
  }

  ret = wait_finder_fixed();

  ret = point_finder_target();

  flg = 1;
  cnt = 0;
  while (flg) {
    /* move star to target position in finder image */
    ret = point_finder_target();

    if (ret == -1) {
      /* succeeded */
      flg = 0;
    }
    if (ret == EXIT_FAILURE) {
      printf("# point finder failed.\n");
      return;
    }
    /* otherwise (ret == 0), more motion would be needed
     * sleep for a while and try again
     */
    if (ret == 0) {
      cnt++;
      if (cnt > 10) {
	printf("# point finder failed.\n");
	return;
      }
      printf("# pointing: trying to move star to target position in finder. (%d time(s))\n", cnt);
      sleep(2);
    }
  }


}

/* callback for stop-op. button */
/* 2004.02.18 v0.5.5- */
void callback_stopop_button(GtkWidget *widget, gpointer pointer)
{
  GtkWidget *dialog_action_area, *vbox, *hbox;
  GtkWidget *button;
  GSList *group = NULL;
  gchar *text[3] = {"Back to Manual Mode", "Rest Scope", "Close Dome"};

  dialog = gtk_dialog_new();
  gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
  gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
  dialog_action_area = GTK_DIALOG(dialog)->action_area;
  vbox = GTK_DIALOG(dialog)->vbox;

  rb[0] = gtk_radio_button_new_with_label(NULL, text[0]);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rb[0]), TRUE);
  gtk_box_pack_start(GTK_BOX(vbox), rb[0], TRUE, TRUE, 0);
  gtk_widget_show(rb[0]);
  group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(rb[0]));

  rb[1] = gtk_radio_button_new_with_label(group, text[1]);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rb[1]), FALSE);
  gtk_box_pack_start(GTK_BOX(vbox), rb[1], TRUE, TRUE, 0);
  gtk_widget_show(rb[1]);

  rb[2] = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(rb[1]), text[2]);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(rb[2]), FALSE);
  gtk_box_pack_start(GTK_BOX(vbox), rb[2], TRUE, TRUE, 0);
  gtk_widget_show(rb[2]);

  hbox = gtk_hbox_new (FALSE, 0);
  /* cancel button */
  button = gtk_button_new_with_label ("Cancel");
  /* dialog_click_cancel() is in opmode.c */
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_click_cancel), dialog);
  gtk_box_pack_start(GTK_BOX (hbox), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  /* ok button */
  button = gtk_button_new_with_label ("Ok");
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(dialog_stopop_ok), dialog);
  gtk_box_pack_start(GTK_BOX (hbox), button, TRUE, TRUE, 2);
  gtk_widget_show(button);

  gtk_box_pack_start(GTK_BOX(dialog_action_area), hbox, TRUE, TRUE, 2);
  gtk_widget_show(hbox);

  gtk_widget_show(dialog);
  gtk_grab_add(GTK_WIDGET(dialog));

}

void dialog_stopop_ok(GtkWidget *widget, gpointer data) {
  int sel = 0;

  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb[0])) == TRUE)  sel = 1;
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb[1])) == TRUE)  sel = 2;
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb[2])) == TRUE)  sel = 3;

  if (sel == 3) {
    stop_operation(); /* in telctl_automatic.c */
  } else {
    if (sel >= 1) { /* stop automatic mode */
      stoptimer();
      reset_starfinding(); /* in cap_window_callbacks.c */
      gtk_widget_hide((GtkWidget*)window_capture);
      mseemon.opmode = 0;
      mseemon.is_capturing = 0;
    }
    if (sel >= 2) { /* rest telescope */
      mseemon.is_pointing = 0;
      sleepTel(); /* in protocol.c */
    }
    update_main_displays();
  }

  gtk_widget_destroy(GTK_WIDGET(data));
}

/* callback: open capture window */
void callback_open_window_cap (GtkWidget *widget, gpointer data)
{
  gtk_widget_show((GtkWidget*)data);

  if (timertag == -1) {
    starttimer();
  }
  /* capture flag */
  mseemon.is_capturing = 1;
  
  #ifdef DEBUG
  printf("g_lamp_area1:%p\n", g_lamp_area1);
  printf("g_lamp_area1/window:%p\n", g_lamp_area1->window);
  #endif

  /* set lamps */
  set_lamp(g_lamp_area1, 1);

  /* check output file is opened */
  if (fout == NULL) {
    setoutputfile(); /* in outputlog.c */
  }
}


/* open capture window  (not callback) 
 *  added v0.6.0 20041122 iwata */
void open_window_cap (void) 
{
  gtk_widget_show(window_capture);

  if (timertag == -1) {
    starttimer();
  }
  /* capture flag */
  mseemon.is_capturing = 1;

  #ifdef DEBUG
  printf("g_lamp_area1:%p\n", g_lamp_area1);
  printf("g_lamp_area1/window:%p\n", g_lamp_area1->window);
  #endif

  /* set lamps */
  set_lamp(g_lamp_area1, 1);

  /* check output file is opened */
  if (fout == NULL) {
    setoutputfile(); /* in outputlog.c */
  }
}


/* callback for hide window */
void callback_hide_window_cap (GtkWidget *widget, gpointer data)
{
  gtk_widget_hide((GtkWidget*)data);
  stoptimer();
  /* capture flag */
  mseemon.is_capturing = 0;

  /* abort automatic proc. */
  reset_starfinding();
  mseemon.is_pointing = 0;
}

