#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <gtk/gtk.h>

#include "seemon2.h"

/* set ppm file paths 
 * v0.4.0u 2003.05.16
 */
void set_ppm_path(void) {
  int i, n;
  char dum[256];
  char i0, i1, i2;

  strcpy(mseemon.dvfilepath, QPPMPATH);
  strcat(mseemon.dvfilepath, "tmp000000.ppm");

  for (i = 0; i < NSEQ; i++) {
    strcpy(mseemon.dvseqpath[i], PPMPATH);
    strcat(mseemon.dvseqpath[i], "tmp000");
    n = strlen(mseemon.dvseqpath[i]);
    i2 = 48;
    i1 = (char)((i%100)/10) + 48;
    i0 = (char)(i%10) + 48;
    mseemon.dvseqpath[i][n] = i2;
    mseemon.dvseqpath[i][n+1] = i1;
    mseemon.dvseqpath[i][n+2] = i0;
    mseemon.dvseqpath[i][n+3] = '\0';
    strcat(mseemon.dvseqpath[i], ".ppm");
    //    #ifdef DEBUG
    //    printf("%s\n", mseemon.dvseqpath[i]);
    //    #endif
  }
}

/* from saveres.c (partly modified) */
/* name of default per-user dir and name of file that can override */
static char mydirdef[] = "~/XEphem";
static char mdovride[] = "~/.xephemrc";
static char mdres[] = "XEphem.PrivateDir";
#define	MRNAM	1024		/* max chars in resource name (not critical) */
#define	MLL	1024		/* max line length (not critical) */

char myclass[] = "XEphem";
static int nmyclass;		/* handy length of myclass[] */

static char sharedir[] = "/usr/local/xephem";
static char defmydir[] = "/home/iwata/XEphem";

/* 
 * from homeio.c
 */

/* if path starts with `~' replace with $HOME.
 * we also remove any leading or trailing blanks, and trailing / or \
 * caller should save returned string before calling us again.
 */
char *
expand_home (path)
char *path;
{
	static char *mpath;
	static char *home;
	static int homel;
	char *p;
	int l;

	/* get home, if we don't already know it */
	if (!home) {
	    home = getenv ("HOME");
	    if (home)
		homel = strlen (home);
	}

	/* start mpath so we can always just use realloc */
	if (!mpath)
	    mpath = malloc (1);

	/* skip leading blanks */
	l = strlen (path);
	while (*path == ' ') {
	    path++;
	    l--;
	}

	/* move '\0' back past any trailing baggage */
	for (p = &path[l-1]; p >= path; --l)
	    if (*p == ' ' || *p == '/' || *p == '\\')
		*p-- = '\0';
	    else
		break;

	/* prepend home if starts with ~ */
	if (path[0] == '~' && home)
	    sprintf (mpath = realloc (mpath, homel+l), "%s%s", home, path+1);
	else
	    strcpy (mpath = realloc(mpath, l+1), path);

	return (mpath);
}

/* return 0 if the given file exists, else -1.
 * substitute HOME if name starts with '~'.
 */
int
existsh (name)
char *name;
{
	struct stat s;

	return (stat (expand_home(name), &s));
}

/* return a string for whatever is in errno right now.
 * I never would have imagined it would be so crazy to turn errno into a string!
 */
char* syserrstr ()
{
#if defined(__STDC__)
/* some older gcc don't have strerror */
#include <errno.h>
return (strerror (errno));
#else
#if defined(VMS)
#include <errno.h>
#include <perror.h>
#else
#if !defined(__FreeBSD__) && !defined(__EMX__)
/* this is aready in stdio.h on FreeBSD */
/* this is already in stdlib.h in EMX   M. Goldberg 27 January 1997 for OS/2 */
extern char *sys_errlist[];
#endif
extern int errno;
#endif
return (sys_errlist[errno]);
#endif
}

/* get the anchor for all of xephem's support files.
 * use TELHOME env first, else ShareDir X resource, else current dir.
 */
char *
getShareDir()
{
  static char *basedir;

  if (!basedir) {
    char *th = getenv ("TELHOME");
    if (th) {
      basedir = malloc (strlen(th) + 10);
      if (basedir) {
	(void) sprintf (basedir, "%s/xephem", th);
	if (existsh(basedir) < 0) {
	  (void) sprintf (basedir, "%s/archive", th);
	  if (existsh(basedir) < 0) {
	    free (basedir);
	    basedir = NULL;
	  }
	}
      }
    }
    if (!basedir) {
      // iwata: I do not understand what this does..
      //char *homebase = expand_home (getXRes ("ShareDir", "."));
      char *homebase = sharedir;
      basedir = strcpy(malloc(strlen(homebase)+1), homebase);
    }
  }

  return (basedir);

}

/* like fopen() but substitutes HOME if name starts with '~'
 */
FILE *
fopenh (name, how)
char *name;
char *how;
{
  return (fopen (expand_home(name), how));
}




/* 
 * from saveres.c
 */

/* copy from[] to to[], sans any white space on either end.
 */
static void
cpyNoWS (to, from)
char *to;
char *from;
{
	char *lastnwsp;		/* last non w/s char in to not counting '\0' */

	while (isspace(*from))
	    from++;
	for (lastnwsp = NULL; (*to = *from) != '\0'; to++, from++)
	    if (!isspace(*to))
		lastnwsp = to;
	if (lastnwsp)
	    *++lastnwsp = '\0';
}

/* given a full resource spec, extract name, sans any surrounding white space.
 * return 0 if ok, or -1 if doesn't even look like a resource.
 */
static int
crackNam (res, nam)
char *res, *nam;
{
  char *colp = strchr (res, ':');
  char wsnam[MRNAM];
	
  if (!colp || strncmp (res, myclass, nmyclass))
    return (-1);
  sprintf (wsnam, "%.*s", colp-res, res);
  cpyNoWS (nam, wsnam);
  return(0);
}

/* given a full resource spec, extract value, sans any surrounding white space.
 * return 0 if ok, or -1 if doesn't even look like a resource.
 */
static int
crackVal (res, val)
char *res, *val;
{
	char *colp = strchr (res, ':');

	if (!colp || strncmp (res, myclass, nmyclass))
	    return (-1);
	cpyNoWS (val, colp+1);
	return (0);
}


/* return full path of per-user working directory,
 * allowing for possible override.
 */
char *
getPrivateDir()
{
  static char *mydir;

  if (!mydir) {
    /* try mdovride else use default */
    FILE *ofp = fopenh (mdovride, "r");
    char *vhome, *vp = NULL;
    char nam[MRNAM], val[MLL], buf[MLL];

    if (ofp) {
      while (fgets (buf, sizeof(buf), ofp)) {
	if (!crackNam (buf, nam) && !strcmp (nam, mdres) &&
	    !crackVal (buf, val)) {
	  vp = val;
	  break;
	} 
      }
      fclose(ofp);
      if (!vp)
	fprintf (stderr, "%s: %s not found. Using %s\n",
		 mdovride, mdres, mydirdef);
    }
    if (!vp)
      vp = mydirdef;
    vhome = expand_home(vp);
    // iwata:
    //	    mydir = XtNewString (vhome);	/* macro! */
    mydir = defmydir;
    if (access (mydir, X_OK) < 0 && mkdir (mydir, 0744) < 0) {
      /* don't try and fake it */
      printf ("%s: %s\n", mydir, syserrstr());
      //      exit(1);
      // modified 20041209 v0.6.5 iwata
      return(NULL);
    }
  }

  return (mydir);
}


/*
 * from preferences.c
 */

/* record of preferences values */
static int prefs[NPREFS];

/* called anytime we want to know a preference.
 */
int
pref_get(pref)
Preferences pref;
{
	return (prefs[pref]);
}

/* call to force a certain preference, return the old setting.
 * Use this wisely.. it does *not* change the menu system.
 * Invented to support forcing MDY in fs_date(), so far no other uses justified.
 */
int
pref_set (pref, new)
Preferences pref;
int new;
{
	int prior = pref_get(pref);
	prefs[pref] = new;
	return (prior);
}


/* from libastro/formats.c */
void
fs_sexa (out, a, w, fracbase)
char *out;
double a;
int w;
int fracbase;
{
	unsigned long n;
	int d;
	int f;
	int m;
	int s;
	int isneg;

	/* save whether it's negative but do all the rest with a positive */
	isneg = (a < 0);
	if (isneg)
	    a = -a;

	/* convert to an integral number of whole portions */
	n = (unsigned long)(a * fracbase + 0.5);
	d = n/fracbase;
	f = n%fracbase;

	/* form the whole part; "negative 0" is a special case */
	if (isneg && d == 0)
	    (void) sprintf (out, "%*s-0", w-2, "");
	else
	    (void) sprintf (out, "%*d", w, isneg ? -d : d);
	out += w;

	/* do the rest */
	switch (fracbase) {
	case 60:	/* dd:mm */
	    m = f/(fracbase/60);
	    (void) sprintf (out, ":%02d", m);
	    break;
	case 600:	/* dd:mm.m */
	    (void) sprintf (out, ":%02d.%1d", f/10, f%10);
	    break;
	case 3600:	/* dd:mm:ss */
	    m = f/(fracbase/60);
	    s = f%(fracbase/60);
	    (void) sprintf (out, ":%02d:%02d", m, s);
	    break;
	case 36000:	/* dd:mm:ss.s*/
	    m = f/(fracbase/60);
	    s = f%(fracbase/60);
	    (void) sprintf (out, ":%02d:%02d.%1d", m, s/10, s%10);
	    break;
	case 360000:	/* dd:mm:ss.ss */
	    m = f/(fracbase/60);
	    s = f%(fracbase/60);
	    (void) sprintf (out, ":%02d:%02d.%02d", m, s/100, s%100);
	    break;
	default:
	    printf ("fs_sexa: unknown fracbase: %d\n", fracbase);
	    //	    exit(1);
	    // modified 20041209 v0.6.5 iwata
	    return;
	}
}

/* put the given modified Julian date, jd, in out[] according to preference
 * format.
 */
void
fs_date (out, jd)
char out[];
double jd;
{
	int p = pref_get (PREF_DATE_FORMAT);
	int m, y;
	double d;

	mjd_cal (jd, &m, &d, &y);
	/* beware of %g rounding day up */
	if ((d < 1.0 && d - floor(d) >= .9999995)
				    || (d < 10.0 && d - floor(d) >= .999995)
				    || (d >= 10.0 && d - floor(d) >= .99995))
	    mjd_cal (mjd_day(jd+0.5), &m, &d, &y);

	switch (p) {
	case PREF_YMD:
	    (void) sprintf (out, "%4d/%02d/%02.6g", y, m, d);
	    break;
	case PREF_DMY:
	    (void) sprintf (out, "%2.6g/%02d/%-4d", d, m, y);
	    break;
	case PREF_MDY:
	    (void) sprintf (out, "%2d/%02.6g/%-4d", m, d, y);
	    break;
	default:
	    printf ("fs_date: bad date pref: %d\n", p);
	    //	    exit (1);
	    // modified 20041209 v0.6.5 iwata
	    return;
	}
}



/*
 * from libastro/dbfmt.c
 */

#define ASIZ(a) (sizeof(a)/sizeof(a[0]))

/* given an *op and a field id, add it to the given text buffer bp.
 * return the number of characters added to bp.
 */
static int
db_get_field (op, id, bp)
Obj *op;
int id;
char *bp;
{
  char *bpsave = bp;
  double tmp;

  /* include all the enums and in numeric order to give us the best
   * possible chance the compiler will implement this as a jump table.
   */
  switch (id) {
  case F_RA:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_sexa (bp, radhr(op->f_RA), 2, 36000);
    bp += strlen(bp);
    break;
  case F_DEC:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_sexa (bp, raddeg(op->f_dec), 3, 3600);
    bp += strlen(bp);
    break;
  case F_EPOCH:
    mjd_year (op->f_epoch, &tmp);
    sprintf (bp, ",%.6g", tmp); /* %.7g gives 2000.001 */
    bp += strlen(bp);
    break;
  case F_MAG:
    sprintf (bp, ",%6.2f", get_mag(op));
    bp += strlen(bp);
    break;
  case F_SIZE:
    sprintf (bp, ",%.7g", op->f_size);
    bp += strlen(bp);
    if (op->f_ratio || op->f_pa) {
      sprintf (bp,"|%g|%g", op->f_size*get_ratio(op), raddeg(get_pa(op)));
      bp += strlen(bp);
    }
    break;
  case F_CLASS:
    if (op->f_class) {
      sprintf (bp, "|%c", op->f_class);
      bp += strlen(bp);
    }
    break;
  case F_SPECT:
    if (op->f_spect[0] != '\0') {
      sprintf (bp, "|%c", op->f_spect[0]);
      bp += strlen(bp);
      if (op->f_spect[1] != '\0') {
	sprintf (bp, "%c", op->f_spect[1]);
	bp += strlen(bp);
      }
    }
    break;
    
  case E_INC:
    sprintf (bp, ",%.7g", op->e_inc);
    bp += strlen(bp);
    break;
  case E_LAN:
    sprintf (bp, ",%.7g", op->e_Om);
    bp += strlen(bp);
    break;
  case E_AOP:
    sprintf (bp, ",%.7g", op->e_om);
    bp += strlen(bp);
    break;
  case E_A:
    sprintf (bp, ",%.7g", op->e_a);
    bp += strlen(bp);
    break;
  case E_N:
    /* retired */
    sprintf (bp, ",");
    bp += strlen(bp);
    break;
  case E_E:
    sprintf (bp, ",%.7g", op->e_e);
    bp += strlen(bp);
    break;
  case E_M:
    sprintf (bp, ",%.7g", op->e_M);
    bp += strlen(bp);
    break;
  case E_CEPOCH:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_date (bp, op->e_cepoch);
    bp += strlen(bp);
    break;
  case E_EPOCH:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_date (bp, op->e_epoch);
    bp += strlen(bp);
    break;
  case E_M1:
    if (op->e_mag.whichm == MAG_gk) {
      sprintf (bp, ",g%.7g", op->e_mag.m1);
      bp += strlen(bp);
    } else if (op->e_mag.whichm == MAG_HG) {
      sprintf (bp, ",H%.7g", op->e_mag.m1);
      bp += strlen(bp);
    } else {
      sprintf (bp, ",%.7g", op->e_mag.m1);
      bp += strlen(bp);
    }
    break;
  case E_M2:
    sprintf (bp, ",%.7g", op->e_mag.m2);
    bp += strlen(bp);
    break;
  case E_SIZE:
    sprintf (bp, ",%.7g", op->e_size);
    bp += strlen(bp);
    break;
    
  case H_EP:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_date (bp, op->h_ep);
    bp += strlen(bp);
    break;
  case H_INC:
    sprintf (bp, ",%.7g", op->h_inc);
    bp += strlen(bp);
    break;
  case H_LAN:
    sprintf (bp, ",%.7g", op->h_Om);
    bp += strlen(bp);
    break;
  case H_AOP:
    sprintf (bp, ",%.7g", op->h_om);
    bp += strlen(bp);
    break;
  case H_E:
    sprintf (bp, ",%.7g", op->h_e);
    bp += strlen(bp);
    break;
  case H_QP:
    sprintf (bp, ",%.7g", op->h_qp);
    bp += strlen(bp);
    break;
  case H_EPOCH:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_date (bp, op->h_epoch);
    bp += strlen(bp);
    break;
  case H_G:
    sprintf (bp, ",%.7g", op->h_g);
    bp += strlen(bp);
    break;
  case H_K:
    sprintf (bp, ",%.7g", op->h_k);
    bp += strlen(bp);
    break;
  case H_SIZE:
    sprintf (bp, ",%.7g", op->h_size);
    bp += strlen(bp);
    break;
    
  case P_EP:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_date (bp, op->p_ep);
    bp += strlen(bp);
    break;
  case P_INC:
    sprintf (bp, ",%.7g", op->p_inc);
    bp += strlen(bp);
    break;
  case P_AOP:
    sprintf (bp, ",%.7g", op->p_om);
    bp += strlen(bp);
    break;
  case P_QP:
    sprintf (bp, ",%.7g", op->p_qp);
    bp += strlen(bp);
    break;
  case P_LAN:
    sprintf (bp, ",%.7g", op->p_Om);
    bp += strlen(bp);
    break;
  case P_EPOCH:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_date (bp, op->p_epoch);
    bp += strlen(bp);
    break;
  case P_G:
    sprintf (bp, ",%.7g", op->p_g);
    bp += strlen(bp);
    break;
  case P_K:
    sprintf (bp, ",%.7g", op->p_k);
    bp += strlen(bp);
    break;
  case P_SIZE:
    sprintf (bp, ",%.7g", op->p_size);
    bp += strlen(bp);
    break;
    
  case ES_EPOCH:
    sprintf (bp, ",");
    bp += strlen(bp);
    fs_date (bp, op->es_epoch);
    bp += strlen(bp);
    break;
  case ES_INC:
    sprintf (bp, ",%.7g", op->es_inc);
    bp += strlen(bp);
    break;
  case ES_RAAN:
    sprintf (bp, ",%.7g", op->es_raan);
    bp += strlen(bp);
    break;
  case ES_E:
    sprintf (bp, ",%.7g", op->es_e);
    bp += strlen(bp);
    break;
  case ES_AP:
    sprintf (bp, ",%.7g", op->es_ap);
    bp += strlen(bp);
    break;
  case ES_M:
    sprintf (bp, ",%.7g", op->es_M);
    bp += strlen(bp);
    break;
  case ES_N:
    sprintf (bp, ",%.7g", op->es_n);
    bp += strlen(bp);
    break;
  case ES_DECAY:
    sprintf (bp, ",%.7g", op->es_decay);
    bp += strlen(bp);
    break;
  case ES_ORBIT:
    sprintf (bp, ",%d", op->es_orbit);
    bp += strlen(bp);
    break;
  case ES_DRAG:
    sprintf (bp, ",%.7g", op->es_drag);
    bp += strlen(bp);
    break;
    
  default:
    printf ("BUG! db_set_field: bad id: %d\n", id);
    //    exit (1);
    // modified 20041209 v0.6.5 iwata
    return;
  }

  return (bp - bpsave);
}

/* write the given Obj in .edb format to lp[].
 * we do _not_ include a trailing '\n'.
 */
void db_write_line (op, lp)
Obj *op;
char *lp;
{
  int priorpref;
  int i;

  /* .edb format always uses MDY.
   * N.B. must restore old value before returning from here!
   */
  priorpref = pref_set (PREF_DATE_FORMAT, PREF_MDY);

  switch (op->o_type) {
  case FIXED: {
    static int ids[] = {F_CLASS, F_SPECT, F_RA, F_DEC, F_MAG, F_EPOCH, F_SIZE}; 

    sprintf (lp, "%s,f", op->o_name);
    lp += strlen(lp);
    for (i = 0; i < ASIZ(ids); i++)
      lp += db_get_field (op, ids[i], lp);
    break;
  }

  case ELLIPTICAL: {
    static int ids[] = {E_INC, E_LAN, E_AOP, E_A, E_N, E_E, E_M, E_CEPOCH, E_EPOCH, E_M1, E_M2, E_SIZE};

    sprintf (lp, "%s,e", op->o_name);
    lp += strlen(lp);
    for (i = 0; i < ASIZ(ids); i++) 
      lp += db_get_field (op, ids[i], lp);
    break;
  }
  
  case HYPERBOLIC: {
    static int ids[]= {H_EP, H_INC, H_LAN, H_AOP, H_E, H_QP, H_EPOCH, H_G, H_K, H_SIZE};
    
    sprintf (lp, "%s,h", op->o_name);
    lp += strlen(lp);
    for (i = 0; i < ASIZ(ids); i++)
      lp += db_get_field (op, ids[i], lp);
    break;
  }
  
  case PARABOLIC: {
    static int ids[] = {P_EP, P_INC, P_AOP, P_QP, P_LAN, P_EPOCH, P_G, P_K, P_SIZE};

    sprintf (lp, "%s,p", op->o_name);
    lp += strlen(lp);
    for (i = 0; i < ASIZ(ids); i++)
      lp += db_get_field (op, ids[i], lp);
    break;
  }
  
  case EARTHSAT: {
    static int ids[] = {ES_EPOCH, ES_INC, ES_RAAN, ES_E, ES_AP, ES_M, ES_N, ES_DECAY,ES_ORBIT,ES_DRAG};
    
    sprintf (lp, "%s,E", op->o_name);
    lp += strlen(lp);
    for (i = 0; i < ASIZ(ids); i++)
      lp += db_get_field (op, ids[i], lp);
    break;
  }
  
  case PLANET:
    sprintf (lp, "%s,P", op->o_name);
    lp += strlen(lp);
    break;
    
  default:
    printf ("Unknown type for %s: %d\n", op->o_name, op->o_type);
    //    exit(1);
    // modified 20041209 v0.6.5 iwata
    return;
  }
  
  /* restore date format preference */
  (void) pref_set (PREF_DATE_FORMAT, priorpref);
}

