/* for log file output
 * 2003.01.29-
 * Time-stamp: <2005-12-13 15:18:01 dimm>
 */
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <gtk/gtk.h>

#include "seemon2.h"

int setoutputfile (void) {
  char outstr[256];

  /* update ctime */
  get_localtime(&(mseemon.ctime));

//  sprintf(outstr, "%s/seemon%04d%02d%02d%02d%02d%02d.log", 
// changed by T.Hattori, 2004/07/14
  sprintf(outstr, "%s/seemon%04d%02d%02d.log", 
	  LOGPATH,
	  mseemon.ctime.year, 
	  mseemon.ctime.month,
	  mseemon.ctime.day);
//	  mseemon.ctime.hour,
//	  mseemon.ctime.min,
//	  mseemon.ctime.sec);

  printf("output file: %s\n", outstr);

  if ((fout = fopen(outstr, "a")) == NULL) {
    printf("failed in opening logfile %s.\n",outstr);
    return(EXIT_FAILURE);
  }

  fprintf(fout, "#logfile of seemon2 version %s\n", VERSION);
  fprintf(fout, "#date-time          cg0x   cg0y   cg1x   cg1y   diffcgx     diffcgy      r0x      r0y      fwhmx  fwhmy fwhmcx fwhmcy ndata  telra  teldc telha telel\n");

  return(EXIT_SUCCESS);
}

/* close log file */
void closeoutputfile(void) {
  fclose(fout);
}

/* output current FWHM measured value
 * 2005.12.13 iwata */
int put_current_seeing(dcoord fwhm) {
  FILE *out;

  if ((out=fopen(CURRPATH, "w")) == NULL) {
    printf("failed opening %s.\n", CURRPATH);
    return(EXIT_FAILURE);
  } else {
    fprintf(out, "%04d/%02d/%02d %02d:%02d ", 
	    mseemon.ctime.year, 
	    mseemon.ctime.month,
	    mseemon.ctime.day,
	    mseemon.ctime.hour,
	    mseemon.ctime.min);
    fprintf(out, "%5.2f %5.2f \n", fwhm.x, fwhm.y);
  }
  fclose(out);
}

/* unset current seeing in the file CURRPATH 
 * 2005.12.13 iwata */
void unset_current_seeing(void) {
  dcoord f;
  f.x = -1.0; f.y = -1.0;
  put_current_seeing(f);
}
