/*
* Header File for the Telescope Control protocols for the Meade LX200
* Author:  John Kielkopf (kielkopf@louisville.edu)
*
* This file contains header information used in common with xmtel.
*
*/

/* The following parameters are used to set speed and direction. */
/* Do not change these values. */


#define	GUIDE		1
#define	CENTER		2
#define	FIND		4
#define	SLEW		8

#define	NORTH		1
#define	EAST		2
#define	SOUTH		4
#define	WEST		8

/* These are user defined quantities that set the limits over which it */
/* is safe to operate the telescope.  */


/* LOWER is the number of degrees from the zenith that you will allow. */
/* Use 80, for example, to keep the eyepiece end out of the fork arm space */
/* of an LX200 telescope. */

#define LOWER         90.

/* HIGHER is the horizon.  0 is an unobstructed horizon in every direction. */
/* Use 10, for example, to limit sighting below 10 degrees above the horizon. */

#define HIGHER         0.
