#!/usr/bin/perl -w
# 2004.12.07 iwata

use CGI qw(:standard);

# files and paths
$loglistpath="/net/dimm/dimm1/log/loglist.txt";
$logpath = "/usr/local/apache/htdocs/dimm/dimm1/log/";
$cgifile = "dimmstat1.cgi";
$altcgi = "http://www.oao.nao.ac.jp/cgi-bin/dimm1.cgi";

$th = 10;   # FWHM threshold
$limit = 3; # clipping sigma

$maxdate = 20020101;
$n = 0;
open(IN, $loglistpath);
while (<IN>) {
    chomp();
    $filename = $_;
    $loglist[$n] = $filename;
    $n++;

    if ($filename =~ /.log/) {
	$date = $filename;
	$date =~ s/seemon//;
	$date =~ s/.log//;
	if ($date > $maxdate) {
	    $maxdate = $date;
	    $logfile = $filename;
	}
	# year list
	$year = substr($date, 0, 4);
	$flg = 0;
	for ($i = 0; $i < $yn; $i++) {
	    if ($ystr[$i] == $year) {
		$flg = 1;
	    }
	}
	if ($flg == 0) {
	    $ystr[$yn] = $year;
	    $yn++;
	}

	# month list
	$mon = substr($date, 4, 2);
	for ($i = 1; $i < 13; $i++) {
	    if ($i == $mon) {
		$mflg[$i] = 1;
	    }
	}

	# day list
	$day = substr($date, 6, 2);
	for ($i = 0; $i < 32; $i++) {
	    if ($i == $day) {
		$dflg[$i] = 1;
	    }
	}
    }
}
close(IN);

print header;
print start_html("DIMM statistics");

$year1  = -1;
$month1 = -1;
$date1  = -1;
$year2  = -1;
$month2 = -1;
$date2  = -1;

if (param()) {
    $year1  = param("year1");
    $month1 = param("month1");
    $date1  = param("date1");
    $year2  = param("year2");
    $month2 = param("month2");
    $date2  = param("date2");

    $t1 = $year1.$month1.$date1;
    $t2 = $year2.$month2.$date2;

    open(IN, $loglistpath);
    $n = 0;
    while (<IN>) {
	if ($_ !~ /^\#/) {
	    @fld = split;
	    chomp();
	    $t = substr($_, 6, 8);

	    if ($t >= $t1 && $t <= $t2) {
		$infile[$n] = $logpath.$_;
		$n++;
	    }
	}
    }
    close(IN);

    $m = 0;
    for ($i = 0; $i < $n; $i++) {
	open(IN, $infile[$i]) || die "failed in opening $infile[$i]";
	while (<IN>) {
	    if ($_ !~ /^\#/) {
		@fld = split;
		$tx = $fld[11];
		$ty = $fld[12];
		if ($tx > 0 && $ty > 0 && $tx < $th && $ty < $th) {
		    $f1[$m] = $tx;
		    $f2[$m] = $ty;
		    $m++;
		}
	    }
	}
    }

    printf "<p>#number of data points: %d.</p>\n", $m;

    @fs1 = sort{$a <=> $b} @f1;
    @fs2 = sort{$a <=> $b} @f2;

#    printf "# finished sorting.\n";

    for ($i = 0; $i < $m; $i++) {
	$fc[$i][0] = $fs1[$i];
	$fc[$i][1] = $fs2[$i];
	$flg[$i][0] = 1;
	$flg[$i][1] = 1;
    }

    for ($k = 0; $k < 2; $k++) {
	$prevnum = -1;
	$loopflg = 1;
	while ($loopflg) {
	    # copy data
	    $pt = 0;
	    for ($i = 0; $i < $m; $i++) {
		if ($flg[$i][$k]) {
		    $x[$pt] = $fc[$i][$k];
		    $pt++;
		}
	    }
	    $num = $pt;

	    # mean
	    $tot = 0.;
	    for ($i = 0; $i < $num; $i++) {
		$tot += $x[$i];
	    }
	    $mean = ($tot * 1.0) / $num;

	    # stddev
	    $tot = 0.;
	    for ($i = 0; $i < $num; $i++) {
		$y = $x[$i] - $mean;
		$tot += $y**2;
	    }
	    $stddev = sqrt($tot/$num);

	    # median
	    $y = $num % 2;
	    if ($y == 0) {
		# num is even
		$y = $num / 2;
		$median = ($x[$y] + $x[$y+1]) / 2.;
	    } else {
		# num is odd
		$y = $num /2 + 1;
		$median = $x[$y];
	    }

	    if ($num == $prevnum) {
		$loopflg = 0;
	    } else {
		$prevnum = $num;
		$low = $median - $limit * $stddev;
		$hgh = $median + $limit * $stddev;

		for ($i = 0; $i < $m; $i++) {
		    if ($fc[$i][$k] < $low || $fc[$i][$k] > $hgh) {
			$flg[$i][$k] = 0;
		    }
		}
	    }
	}
	$fmean[$k] = $mean;
	$fsig[$k] = $stddev;
	$fmed[$k] = $median;
	$fnum[$k] = $num;

	# histgram
	$h0 = 0.;
	$h1 = 4.;
	$step = 0.1;

	$x1 = $h0;
	$x2 = $x1 + $step;
	$loopflg = 1;
	$n = 0;
	$i = 0;
	while ($loopflg) {
	    $hnum[$n][$k] = 0;
	    while ($x[$i] <= $x2) {
		$hnum[$n][$k]++;
		$i++;
	    }
	    $x1 += $step;
	    $x2 = $x1 + $step;
	    $n++;
	    if ($x2 > $h1) {
		$loopflg = 0;
	    }
	}
    }

    printf "<p># num mean median sigma <br />\n";
    for ($k = 0; $k < 2; $k++) {
	printf "%7d %6.3f %6.3f %6.3f <br />\n", $fnum[$k], $fmean[$k], $fmed[$k], $fsig[$k];
    }

    printf "</p>\n<p><pre>\n";
    printf "# FWHM1 FWHM2 Num1 Fraction1 Num2 Fraction2\n";

    $h0 = 0.;
    $h1 = 4.;
    $step = 0.1;

    $x1 = $h0;
    $x2 = $x1 + $step;
    $loopflg = 1;
    $n = 0;
    while ($loopflg) {
	printf "%4.1f %4.1f %5d %5.3f %5d %5.3f \n", 
	$x1, $x2, $hnum[$n][0], $hnum[$n][0]/$num, $hnum[$n][1], $hnum[$n][1]/$num;
	$n++;
	$x1 += $step;
	$x2 = $x1 + $step;
	if ($x2 > $h1) {
	    $loopflg = 0;
	}
    }
}
printf "</pre></p>\n";
print hr();

### FORM
print "<form method=\"post\" action=\"/cgi-bin/$cgifile\" enctype=\"application/x-www-form-urlencoded\">";
print "<p>from year <select name=\"year1\">";
for ($i = 0; $i < $yn; $i++) {
    if ($ystr[$i] == $year1) {
	printf " <option selected=\"selected\" value=\"%s\">%s</option>\n", $ystr[$i], $ystr[$i];
    } else {
	printf " <option value=\"%s\">%s</option>\n", $ystr[$i], $ystr[$i];
    }
}
print "</select>";
print "/ month <select name=\"month1\">";
for ($i = 0; $i < 13; $i++) {
    if ($mflg[$i]) {
	if ($month1 == $i) {
	    printf " <option selected=\"selected\" value=\"%02d\">%02d</option>\n", $i, $i;
	} else {
	    printf " <option value=\"%02d\">%02d</option>\n", $i, $i;
	}
    }
}
print "</select>";
print "/ day <select name=\"date1\">";
for ($i = 0; $i < 32; $i++) {
    if ($dflg[$i]) {
	if ($date1 == $i) {
	    printf " <option selected=\"selected\" value=\"%02d\">%02d</option>\n", $i, $i;
	} else {
	    printf " <option value=\"%02d\">%02d</option>\n", $i, $i;
	}
    }
}
print "</select>";

print "<p>  to year <select name=\"year2\">";
for ($i = 0; $i < $yn; $i++) {
    if ($ystr[$i] == $year2) {
	printf " <option selected=\"selected\" value=\"%s\">%s</option>\n", $ystr[$i], $ystr[$i];
    } else {
	printf " <option value=\"%s\">%s</option>\n", $ystr[$i], $ystr[$i];
    }
}
print "</select>";
print "/ month <select name=\"month2\">";
for ($i = 0; $i < 13; $i++) {
    if ($mflg[$i]) {
	if ($month2 == $i) {
	    printf " <option selected=\"selected\" value=\"%02d\">%02d</option>\n", $i, $i;
	} else {
	    printf " <option value=\"%02d\">%02d</option>\n", $i, $i;
	}
    }
}
print "</select>";
print "/ day <select name=\"date2\">";
for ($i = 0; $i < 32; $i++) {
    if ($dflg[$i]) {
	if ($date2 == $i) {
	    printf " <option selected=\"selected\" value=\"%02d\">%02d</option>\n", $i, $i;
	} else {
	    printf " <option value=\"%02d\">%02d</option>\n", $i, $i;
	}
    }
}
print "</select></p>\n";

print "<p><input type=\"submit\" name=\"stat\" value=\"start calc\" /> (Takes Some Time)</p>";
print "</form>";

print hr();
print "<a href=\"".$altcgi."\">Latest Data and Plots</a>";

print end_html;



