#!/usr/bin/perl -w
# auto startup for seemon2
# 2005.01.04

# files
$timefile = "/usr/local/share/seemon2/seemon2.time";
$conffile = "/usr/local/share/seemon2/seemon2.conf";

# get current time
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)= localtime(time);
$ctime = $hour + $min/60.;
$year += 1900;
$mon  += 1;

#printf "%04d/%02d/%02d %02d:%02d:%02d\n", $year, $mon, $mday, $hour, $min, $sec;

$flg0 = 1;

open(IN, $timefile) || die "failed opening $timefile";
while (<IN>) {
    if ($_ !~ /^\#/) {
	@fld = split;
	if ($fld[0] =~ /start/) {
	    if ($fld[1] =~ /cancel/) {
		$flg0 = 0;
	    } else {
		$time0 = $fld[1];
		$flg1 = $fld[2];
	    }
	}
	if ($fld[0] =~ /end/) {
	    $time1 = $fld[1];
	}
    }
}
close(IN);

if ($flg0) {
    # check time 
    if ($ctime >= $time0 &&
	$flg1 == 0) {
	# start obs.

	# time to start op.
	if ($mon == 1) {
	    $stime = 18.1;
	} elsif ($mon == 2) {
	    $stime = 18.6;
	} elsif ($mon == 3) {
	    $stime = 18.85;
	} elsif ($mon == 4) {
	    $stime = 19.35;
	} elsif ($mon == 5) {
	    $stime = 19.6;
	} elsif ($mon == 6) {
	    $stime = 20.1;
	} elsif ($mon == 7) {
	    $stime = 20.1;
	} elsif ($mon == 8) {
	    $stime = 19.6;
	} elsif ($mon == 9) {
	    $stime = 19.1;
	} elsif ($mon == 10) {
	    $stime = 18.35;
	} elsif ($mon == 11) {
	    $stime = 17.85;
	} elsif ($mon == 12) {
	    $stime = 17.6;
	} 

	# time to stop op.
	if ($mon == 1) {
	    $etime = 6.5;
	} elsif ($mon == 2) {
	    $etime = 6.0;
	} elsif ($mon == 3) {
	    $etime = 5.5;
	} elsif ($mon == 4) {
	    $etime = 5.0;
	} elsif ($mon == 5) {
	    $etime = 4.0;
	} elsif ($mon == 6) {
	    $etime = 4.0;
	} elsif ($mon == 7) {
	    $etime = 4.5;
	} elsif ($mon == 8) {
	    $etime = 4.75;
	} elsif ($mon == 9) {
	    $etime = 5.0;
	} elsif ($mon == 10) {
	    $etime = 5.5;
	} elsif ($mon == 11) {
	    $etime = 6.0;
	} elsif ($mon == 12) {
	    $etime = 6.25;
	} 

	open(IN, $conffile) || die "failed opening $conffile";

	$line = 1;
	while (<IN>) {
	    if ($_ !~ /^\#/) {
		@fld = split;
		if ($line == 1) {
		    $dimmid = $fld[0];
		} elsif ($line == 2) {
		    $finder = $fld[0];
		} elsif ($line == 3) {
		    $shutter = $fld[0];
		} elsif ($line == 4) {
		    $guid0   = $fld[0];
		} elsif ($line == 5) {
		    $guid1   = $fld[0];
		} elsif ($line == 6) {
		    $time1   = $fld[0];
		} elsif ($line == 7) {
		    $alt0    = $fld[0];
		} elsif ($line == 8) {
		    $alt1    = $fld[0];
		}
		$line++;
	    }
	}
	close(IN);

	# update config file
	open(OUT, ">$conffile");
	printf OUT "# configuration file for seemon2\n";
	printf OUT "# to be placed at /usr/local/share/seemon2/seemon2.conf\n";
	printf OUT "#  lines starting with '#' will be ignored\n";
	printf OUT "# DIMM ID\n";
	printf OUT "%d\n", $dimmid;
	printf OUT "# socket server (=finder host)\n";
	printf OUT "%s\n", $finder;
	printf OUT "# default IICCD shutter speed\n";
	printf OUT "%d\n", $shutter;
	printf OUT "# guide acceleration\n";
	printf OUT "%d\n", $guid0;
	printf OUT "# guide acceleration limit altitude\n";
	printf OUT "%d\n", $guid1;
	printf OUT "# end time (JST)\n";
	printf OUT "%5.2f\n", $etime+24.;
	printf OUT "# low limit for selecting star\n";
	printf OUT "%5.2f\n", $alt0;
	printf OUT "# low limit for tracking star\n";
	printf OUT "%5.2f\n", $alt1;
	close(OUT);
	
	# update time file
	open(OUT, ">$timefile");
	printf OUT "start %5.2f 1\n", $stime;
	printf OUT "end   %5.2f \n", $etime;

	$outfile = "/mnt/ramdisk/seemon2/command.txt";
	open(OUT, ">$outfile");
	printf OUT "auto\n";
	close(OUT);
    } elsif ($ctime < 12 &&
	     $ctime >= $time1 &&
	     $flg1 == 1) {
	# obs. (should be) ended
	# update time file
	open(OUT, ">$timefile");
	printf OUT "start %5.2f 0\n", $time0;
	printf OUT "end   %5.2f \n", $time1;
	close(OUT);
    }
}


