#!/usr/bin/perl -w
# set auto startup for seemon2
#  calc time to start and set command with "at"
#  set  time to end in conffile
#
# 2005.01.04
# 2005.01.11
# 2005.08.18
# 2006.02.01 add object list path in conffile

# files
$timefile = "/usr/local/share/seemon2/seemon2.time";
$conffile = "/usr/local/share/seemon2/seemon2.conf";
$comfile  = "/usr/local/share/seemon2/seemon2.at";

# get current time
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)= localtime(time);
$ctime = $hour + $min/60.;
$year += 1900;
$mon  += 1;

#printf "%04d/%02d/%02d %02d:%02d:%02d\n", $year, $mon, $mday, $hour, $min, $sec;


# time to start op.
if ($mon == 1) {
    $stime = 18.1;
} elsif ($mon == 2) {
    $stime = 18.6;
} elsif ($mon == 3) {
    $stime = 18.85;
} elsif ($mon == 4) {
    $stime = 19.35;
} elsif ($mon == 5) {
    $stime = 19.6;
} elsif ($mon == 6) {
    $stime = 20.1;
} elsif ($mon == 7) {
    $stime = 20.1;
} elsif ($mon == 8) {
    $stime = 19.6;
} elsif ($mon == 9) {
    $stime = 19.1;
} elsif ($mon == 10) {
    $stime = 18.35;
} elsif ($mon == 11) {
    $stime = 17.85;
} elsif ($mon == 12) {
    $stime = 17.6;
} 

# time to stop op.
if ($mon == 1) {
    $etime = 6.5;
} elsif ($mon == 2) {
    $etime = 6.0;
} elsif ($mon == 3) {
    $etime = 5.5;
} elsif ($mon == 4) {
    $etime = 5.0;
} elsif ($mon == 5) {
    $etime = 4.0;
} elsif ($mon == 6) {
    $etime = 4.0;
} elsif ($mon == 7) {
    $etime = 4.5;
} elsif ($mon == 8) {
    $etime = 4.75;
} elsif ($mon == 9) {
    $etime = 5.0;
} elsif ($mon == 10) {
    $etime = 5.5;
} elsif ($mon == 11) {
    $etime = 6.0;
} elsif ($mon == 12) {
    $etime = 6.25;
} 

open(IN, $conffile) || die "failed opening $conffile";

$line = 1;
while (<IN>) {
    if ($_ !~ /^\#/) {
	@fld = split;
	if ($line == 1) {
	    $dimmid = $fld[0];
	} elsif ($line == 2) {
	    $finder = $fld[0];
	} elsif ($line == 3) {
	    $shutter = $fld[0];
	} elsif ($line == 4) {
	    $guid0   = $fld[0];
	} elsif ($line == 5) {
	    $guid1   = $fld[0];
	} elsif ($line == 6) {
	    $time1   = $fld[0];
	} elsif ($line == 7) {
	    $alt0    = $fld[0];
	} elsif ($line == 8) {
	    $alt1    = $fld[0];
	} elsif ($line == 9) {
	    $hum = $fld[0];
	} elsif ($line ==10) {
	    $net = $fld[0];
	} elsif ($line ==11) {
	    $path = $fld[0];
	}
	$line++;
    }
}
close(IN);

# update config file
open(OUT, ">$conffile");
printf OUT "# configuration file for seemon2\n";
printf OUT "# to be placed at /usr/local/share/seemon2/seemon2.conf\n";
printf OUT "#  lines starting with '#' will be ignored\n";
printf OUT "# DIMM ID\n";
printf OUT "%d\n", $dimmid;
printf OUT "# socket server (=finder host)\n";
printf OUT "%s\n", $finder;
printf OUT "# default IICCD shutter speed\n";
printf OUT "%d\n", $shutter;
printf OUT "# guide acceleration\n";
printf OUT "%d\n", $guid0;
printf OUT "# guide acceleration limit altitude\n";
printf OUT "%d\n", $guid1;
printf OUT "# end time (JST)\n";
printf OUT "%5.2f\n", $etime+24.;
printf OUT "# low limit for selecting star\n";
printf OUT "%5.2f\n", $alt0;
printf OUT "# low limit for tracking star\n";
printf OUT "%5.2f\n", $alt1;
printf OUT "# humidity limit\n";
printf OUT "%5.2f\n", $hum;
printf OUT "# network\n";
printf OUT "%d\n", $net;
printf OUT "# path of object list\n";
printf OUT "%s\n", $path;
close(OUT);
	
# set command
open(OUT, ">$comfile");
printf OUT "echo \"auto\" > /mnt/ramdisk/seemon2/command.txt\n";
close(OUT);
$sh = int($stime);
$sm = int(($stime-$sh)*60);
if ($sm < 10) {
    $sm = "0".$sm;
}

# set start time using at
# if not already set
$flg = 0;
open(IN, "/usr/bin/atq|");
while (<IN>) {
    @fld = split;
    if ($fld[4] eq "dimm") {
	$flg = 1;
    }
}
close(IN);
if ($flg == 0) {
    system("at -f $comfile $sh:$sm");
}
#printf "at -f $comfile $sh:$sm\n";

