/* 
 * socket_client.c
 * 
 *  for communication bet. finder and seemon2
 *
 * 2003.09.05
 * Time-stamp: <2005-02-12 19:02:19 dimm>
 */
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "seemon2.h"

#define	SOCK_NAME	"/tmp/socket"
#define	PORT 8765

int connect_socket(char* hostname) {
  struct sockaddr_in    addr;
  struct hostent	*hp;
  int    len;

  if ((fd_socket = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    return(EXIT_FAILURE);
  }
  
  bzero((char *)&addr, sizeof(addr));

  if((hp=gethostbyname(hostname))==NULL) {
    perror("gethostbyname");
    return(EXIT_FAILURE);
  }
  bcopy(hp->h_addr,&addr.sin_addr,hp->h_length);
  addr.sin_family=AF_INET;
  addr.sin_port=htons(PORT);


  if (connect(fd_socket,(struct sockaddr *)&addr,sizeof(addr)) < 0) {
    perror("connect");
    return(EXIT_FAILURE);
  }

  return(EXIT_SUCCESS);
}

/* v0.5.5: corresponding to finder v0.6.2
 * added rainflg, humidity and domestatus */
int read_finder_coords(void) {
  int ret, tx, ty, tp, tr, th, td;
  char buf[1024], key[10];

  //  #ifdef DEBUG
  //  printf("read_finder_coords called. fd_socket=%d\n", fd_socket);
  //  #endif

  strcpy(key, "go");
  write(fd_socket, key, sizeof(key));

  if (fd_socket < 0) {
    printf("ERROR in read_finder_coords: socket not connected.\n");
    return(1);
  }

  ret = read(fd_socket, buf, sizeof(buf));
  //  printf("read from socket: %s\n",buf);
  printf("read from socket: %s",buf);

  //  sscanf(buf, "%d %d %d", &tx, &ty, &tp);
  sscanf(buf, "%d %d %d %d %d %d", &tx, &ty, &tp, &tr, &th, &td);
  mseemon.finder_star_center.cx = tx;
  mseemon.finder_star_center.cy = ty;
  mseemon.finder_peakval = tp;
  mseemon.rainflg = tr;
  mseemon.humidity = th;
  mseemon.domestatus = td;

  #ifdef DEBUG
  printf("# read_finder_coords: dome:%d\n", td);
  #endif
  return(EXIT_SUCCESS);
}

int disconnect_socket(void) {
  close(fd_socket);
  return(EXIT_SUCCESS);
}
